/*  commandir_record  Version 0.2
    Initial Release Feb 9 2011
    0.2 - March 2011 - Added -g switch to specify gap
 */

#include "libcmdir.h"

extern char * rec_filename;
extern int gap_size;

int main(int argc, char **argv)
{
  int x;
  if(argc == 1)
  {
    printf("commandir_record 0.2\n\n");
    printf(" Record IR codes from a CommandIR III\n\n");

    printf("Usage: commandir_record [-gGAP_SIZE] BUTTON_NAME [BUTTON_NAME] ...\n\n");
    printf(" GAP_SIZE - in microseconds (us): calibrate the recorder to distinguish between repeat signals. Default: 50000\n");
    return 0;
  }
  
  // Init the CommandIR, then record each of the names provided:
  if(!hardware_scan())
  {
    return 0;
  }

  for(x=1; x<argc; x++)
  {
    if(argv[x][0] == '-')
    {
      switch(argv[x][1])
      {
        case 'g':
          gap_size = atoi(&argv[x][2]);
          if(gap_size < 1000)
          {
            printf("Please specify a larger gap size: %d is too small\n", gap_size);
            return -1;
            break;
          }
          printf("Setting gap size to %d\n", gap_size);
          break;
        default:
          printf("Unknown command line argument %c\n", argv[x][1]);
      }
    } else {
      rec_filename = argv[x];
      printf("Recording %s ...\n", rec_filename);
      commandir_rec();
    }
  }
}

