/*  commandir_send  Version 0.2
    Initial Release: Feb 9, 2011  
    0.2 Release: March 26, 2011
 */

#include "libcmdir.h"

extern unsigned int tx_bitmask;
extern char * send_filename;

void transmit_tx_char(char * tx_char)
{
  struct sendir * tx = NULL;
  tx = tx_char_2_struct(tx_char);
  if(tx)
  {
    tx->emitterMask = tx_bitmask;
    commandir_sendir(tx);
  }
}


int main(int argc, char **argv)
{
  char * tx_char = NULL;
  int x, emitter_num;
  unsigned int msDelay = 200;
  
  if(argc == 1)
  {
    printf("commandir_send v0.2\n");
    printf(" Send IR codes from CommandIR\n\n");
    printf("commandir_send [-dDELAY] [[-bEMITTER_BITMASK_HEX] | [-eEMITTERNUM]] FILENAME [FILENAME]...\n\n");
    printf("Examples:\nSend two commands to emitter 3 with a 500ms delay in between:\n");
    printf(" commandir_send -d500 -e3 amp_volup amp_volup\n");
    printf("Send one command to emitters 1, 2, 3 and 4:\n commandir_send -b0F sa_power\n");
    return 0;
  }

  set_all_bitmask(0xff);
  
  for(x=1; x<argc; x++)
  {
    if(argv[x][0] == '-')
    {
      switch(argv[x][1])
      {
        case 'e':
          // Emitter selection
          if(tx_bitmask)
          {
            printf("Cannot specify both -b and -e!\n");
            return -1;
          }
          
          set_all_bitmask(0); // clear bitmask
          emitter_num = atoi(&argv[x][2]);
          if(emitter_num < 1 | emitter_num > 2048)
          {
            printf("Invalid emitter number\n");
            return -1;
          }
          set_long_tx_bit( emitter_num );
          break;
          tx_bitmask = atoi(&argv[x][2]); 
          tx_bitmask = (0x01 << (tx_bitmask-1));
          break;
        case 'b':
          // hex tx_bitmask
          if(tx_bitmask)
          {
            printf("Cannot specify both -e and -b!\n");
            return -1;
          }
          set_all_bitmask(0); // clear bitmask
          convert_set_long(&argv[x][2], strlen(&argv[x][2]));  
          break;
          tx_bitmask = convert_quad(&argv[x][2], strlen(&argv[x][2]));  
          break;
        case 'd':
          msDelay = atoi(&argv[x][2]);
          break;
        case 'r':
          // They're giving us raw codes on the Command Line
          printf("Raw codes - not implemented\n");
          return -1;
      }
    }
  }

  hardware_scan();
  detect_tx_per_commandir();
  
  if(tx_char == NULL)
  {
    for(x=1; x<argc; x++)
    {
      if(argv[x][0] != '-')
      {
        send_filename = argv[x];
        tx_char = load_file(argv[x]);
        if(tx_char)
        {
          transmit_tx_char(tx_char);
          free(tx_char);
          // Only pause if we have another signal to transmit:
          if(x < argc - 1)
            usleep(msDelay * 1000);
        }
      }
    }
  } else { 
    transmit_tx_char(tx_char);
  }
  
  return 0;
}

